
Ruby - Bug #14571

File descriptor leak in resolv.rb

03/02/2018 09:46 PM - quixoten (Devin Christensen)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.3: DONE, 2.4: DONE, 2.5: DONE

Description

There's an edge case in resolv.rb that can lead to file descriptor leaks on a highly saturated system (logstash in our case).
(the cliff at the end is from a restart of the application)

We're using the logstash-filter-dns plugin which uses timeout.

When a timeout fires while waiting for a random port, the new object is never returned to the caller. Instead requester is set to nil.

There's no handle to any sockets that were created in the initializer, so they can't be closed, and one ore more file descriptors is

leaked.

(This if my first patch submission, let me know what I can fix or do better.)

Associated revisions

Revision e6c0a8f19e3f38fdc77906ea545f8d3b0479adf7 - 03/06/2018 02:48 AM - nobu (Nobuyoshi Nakada)

resolv.rb: close socket

lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

sockets before binding, so the sockets get closed when the

requester is closing.

lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

race condition.

lib/resolv.rb (ConnectedUDP#close): ditto.

[ruby-core:85901] [Bug #14571]

From: quixoten (Devin Christensen) quixoten@gmail.com

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62671 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e6c0a8f1 - 03/06/2018 02:48 AM - nobu (Nobuyoshi Nakada)

resolv.rb: close socket

lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

sockets before binding, so the sockets get closed when the

requester is closing.

lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

race condition.

lib/resolv.rb (ConnectedUDP#close): ditto.

[ruby-core:85901] [Bug #14571]

From: quixoten (Devin Christensen) quixoten@gmail.com
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@62671 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ad0b27d0547f97bd114880b78d1cc06230310241 - 03/25/2018 04:12 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@62915 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ad0b27d0 - 03/25/2018 04:12 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_4@62915 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 84ec88a2319cfe716212d62f70bc10e855c2d2aa - 03/28/2018 06:03 AM - U.Nakamura 

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62949 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 84ec88a2 - 03/28/2018 06:03 AM - U.Nakamura 

merge revision(s) 62671: [Backport #14571]
    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@62949 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e804822e7af4602562b16143a4f2d5663cd59013 - 01/07/2019 12:05 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66748 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e804822e7af4602562b16143a4f2d5663cd59013 - 01/07/2019 12:05 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.

    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66748 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision e804822e - 01/07/2019 12:05 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 62671: [Backport #14571]

    resolv.rb: close socket

    * lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

      sockets before binding, so the sockets get closed when the

      requester is closing.
    * lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

    * lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

      race condition.

    * lib/resolv.rb (ConnectedUDP#close): ditto.

    [ruby-core:85901] [Bug #14571]

    From: quixoten (Devin Christensen) <quixoten@gmail.com>

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_5@66748 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 03/06/2018 02:23 AM - nobu (Nobuyoshi Nakada)

Just to clarify, do those file descriptors get closed by GC?

#2 - 03/06/2018 02:44 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED

#3 - 03/06/2018 02:48 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r62671.

resolv.rb: close socket

lib/resolv.rb (UnconnectedUDP#lazy_initialize): store new

sockets before binding, so the sockets get closed when the

requester is closing.

lib/resolv.rb (ConnectedUDP#lazy_initialize): ditto.

lib/resolv.rb (UnconnectedUDP#close): synchronize to get rid of

race condition.

lib/resolv.rb (ConnectedUDP#close): ditto.

[ruby-core:85901] [Bug #14571]

From: quixoten (Devin Christensen) quixoten@gmail.com

#4 - 03/25/2018 04:20 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: REQUIRED to 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE

ruby_2_4 r62915 merged revision(s) 62671.

#5 - 03/28/2018 06:03 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.2: REQUIRED, 2.3: REQUIRED, 2.4: DONE to 2.2: REQUIRED, 2.3: DONE, 2.4: DONE

ruby_2_3 r62949 merged revision(s) 62671.

#6 - 12/16/2018 09:44 PM - naruse (Yui NARUSE)

- Backport changed from 2.2: REQUIRED, 2.3: DONE, 2.4: DONE to 2.3: DONE, 2.4: DONE, 2.5: REQUIRED

#7 - 01/07/2019 12:05 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: DONE, 2.4: DONE, 2.5: REQUIRED to 2.3: DONE, 2.4: DONE, 2.5: DONE

ruby_2_5 r66748 merged revision(s) 62671.

Files

add-failing-tests.patch 1.39 KB 03/02/2018 quixoten (Devin Christensen)
fix-leak.patch 5.01 KB 03/02/2018 quixoten (Devin Christensen)

combined.patch 6.4 KB 03/02/2018 quixoten (Devin Christensen)
